
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Housekeeping_tasksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.create(
            {
                id: data.id || undefined,
        
        scheduled_for_at: data.scheduled_for_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        task_type: data.task_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await housekeeping_tasks.setRoom( data.room || null, {
            transaction,
        });
        
        await housekeeping_tasks.setAssigned_to( data.assigned_to || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.housekeeping_tasks.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: housekeeping_tasks.id,
            },
            data.attachments,
            options,
        );
        

        return housekeeping_tasks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const housekeeping_tasksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                scheduled_for_at: item.scheduled_for_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                task_type: item.task_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const housekeeping_tasks = await db.housekeeping_tasks.bulkCreate(housekeeping_tasksData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < housekeeping_tasks.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.housekeeping_tasks.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: housekeeping_tasks[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return housekeeping_tasks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const housekeeping_tasks = await db.housekeeping_tasks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.scheduled_for_at !== undefined) updatePayload.scheduled_for_at = data.scheduled_for_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.task_type !== undefined) updatePayload.task_type = data.task_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await housekeeping_tasks.update(updatePayload, {transaction});

        
        
        if (data.room !== undefined) {
            await housekeeping_tasks.setRoom(
              
              data.room,
              
              { transaction }
            );
        }
        
        if (data.assigned_to !== undefined) {
            await housekeeping_tasks.setAssigned_to(
              
              data.assigned_to,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.housekeeping_tasks.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: housekeeping_tasks.id,
            },
            data.attachments,
            options,
        );
        

        return housekeeping_tasks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of housekeeping_tasks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of housekeeping_tasks) {
                await record.destroy({transaction});
            }
        });


        return housekeeping_tasks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findByPk(id, options);

        await housekeeping_tasks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await housekeeping_tasks.destroy({
            transaction
        });

        return housekeeping_tasks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findOne(
            { where },
            { transaction },
        );

        if (!housekeeping_tasks) {
            return housekeeping_tasks;
        }

        const output = housekeeping_tasks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.room = await housekeeping_tasks.getRoom({
            transaction
        });
        
        
        output.assigned_to = await housekeeping_tasks.getAssigned_to({
            transaction
        });
        
        
        output.attachments = await housekeeping_tasks.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.rooms,
        as: 'room',
        
        where: filter.room ? {
          [Op.or]: [
            { id: { [Op.in]: filter.room.split('|').map(term => Utils.uuid(term)) } },
            {
              room_number: {
                [Op.or]: filter.room.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'assigned_to',
        
        where: filter.assigned_to ? {
          [Op.or]: [
            { id: { [Op.in]: filter.assigned_to.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.assigned_to.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'housekeeping_tasks',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.scheduled_for_atRange) {
                const [start, end] = filter.scheduled_for_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_for_at: {
                    ...where.scheduled_for_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_for_at: {
                    ...where.scheduled_for_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.task_type) {
                where = {
                    ...where,
                task_type: filter.task_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.housekeeping_tasks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'housekeeping_tasks',
                        'task_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.housekeeping_tasks.findAll({
            attributes: [ 'id', 'task_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['task_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.task_type,
        }));
    }

    
};

